// Definisanje konverzija tipova.

#include <iostream>
#include <cmath>
using namespace std;

class Kompl {
  double re, im;
public:
  Kompl(double r=0, double i=0) // Inicijalizacija i konverzija.
    { re = r; im = i; } 
  explicit operator double()     // Konverzija u double.
    { return sqrt(re*re + im*im); }
  friend double real(Kompl z) { return z.re; }  // Realni deo.
  friend double imag(Kompl z) { return z.im; }  // Imaginarni deo.
  Kompl operator+(Kompl z)                      // Sabiranje.
    { z.re += re; z.im += im; return z; }
  friend ostream& operator<<(ostream& it, const Kompl& z)
    { return it << '(' << z.re << ',' << z.im << ')'; }
};

int main () {
  Kompl a(3, 4); cout << "a       = " << a              << endl;   // (3,4)
  Kompl b = a;   cout << "b       = " << b              << endl;   // (3,4)
  Kompl c = 5;   cout << "c       = " << c              << endl;   // (5,0)
                 cout << "a+b     = " << a + b          << endl;   // (6,8)
                 cout << "a+3     = " << a + 3          << endl;   // (6,4)
                 cout << "|a|+3   = " << double(a) + 3  << endl;   // 8
                 cout << "a+(3,4) = " << a + Kompl(1,2) << endl;   // (4,6)
}

